## kdsoap 1.9.1+dfsg

=== CMakeLists.txt ===
# This is the top-level CMakeLists.txt file for the KDSoap project.
#
# Pass the following variables to cmake to control the build:
# (See INSTALL-cmake.txt for more information)
#
# -DKDSoap_ENFORCE_QT4_BUILD=[true|false]
#  Force building against Qt4, even if Qt5 is found.
#  Default=false
#
# -DKDSoap_STATIC=[true|false]
#  Build static libraries
#  Default=false
#
# -DKDSoap_TESTS=[true|false]
#  Build the test harness.
#  Default=false
#
# -DKDSoap_EXAMPLES=[true|false]
#  Build the examples.
#  Default=true
#
cmake_minimum_required(VERSION 2.8.7)
if(POLICY CMP0020)
  cmake_policy(SET CMP0020 NEW)
endif()
if(POLICY CMP0025)
  cmake_policy(SET CMP0025 NEW)
endif()
if(POLICY CMP0054)
  cmake_policy(SET CMP0054 NEW)
endif()

if("${CMAKE_INSTALL_PREFIX}" STREQUAL "")
  set(USE_DEFAULT_INSTALL_LOCATION True)
else()
  set(USE_DEFAULT_INSTALL_LOCATION False)
endif()

project(KDSoap CXX)

option(
  ${PROJECT_NAME}_ENFORCE_QT4_BUILD
  "Enable if you want to enforce a build with Qt4"
  OFF
)

if(CMAKE_VERSION VERSION_LESS "3.1")
    if(CMAKE_COMPILER_IS_GNUCXX)
        set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
    endif ()
else()
    set(CMAKE_CXX_STANDARD 11)
endif()

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/ ${CMAKE_MODULE_PATH}")

option(${PROJECT_NAME}_STATIC "Build statically" OFF)
option(${PROJECT_NAME}_TESTS "Build the tests" OFF)
option(${PROJECT_NAME}_EXAMPLES "Build the examples" ON)

set(${PROJECT_NAME}_VERSION_MAJOR 1)
set(${PROJECT_NAME}_VERSION_MINOR 9)
set(${PROJECT_NAME}_VERSION_PATCH 1)
set(${PROJECT_NAME}_VERSION ${${PROJECT_NAME}_VERSION_MAJOR}.${${PROJECT_NAME}_VERSION_MINOR}.${${PROJECT_NAME}_VERSION_PATCH})
set(${PROJECT_NAME}_SOVERSION ${${PROJECT_NAME}_VERSION_MAJOR})

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

find_path(BOOST_OPTIONAL_DIR NAMES boost/optional.hpp)
if (BOOST_OPTIONAL_DIR)
    message(STATUS "Found boost/optional.hpp in ${BOOST_OPTIONAL_DIR}")
    include_directories(${BOOST_OPTIONAL_DIR})
    add_definitions(-DBOOST_OPTIONAL_FOUND) # I'd really prefer using configure_file but this is more compatible with qmake
endif()

# setup default install locations
include(InstallLocation)

# try Qt5 first, and prefer that (if found), but only if not disabled via option
if(NOT ${PROJECT_NAME}_ENFORCE_QT4_BUILD)
  find_package(Qt5Core QUIET)
endif()

if(Qt5Core_FOUND)
  find_package(Qt5Network REQUIRED)
  find_package(Qt5Widgets CONFIG)
  set(QT_LIBRARIES Qt5::Core)
  set(QT_USE_FILE "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Qt5Portability.cmake")

  if(Qt5_POSITION_INDEPENDENT_CODE)
    if(CMAKE_VERSION VERSION_LESS 2.8.9)
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
    elseif(NOT CMAKE_VERSION VERSION_LESS 2.8.11)
      if(Qt5Core_VERSION VERSION_LESS 5.1)
        set_property(TARGET Qt5::Core PROPERTY INTERFACE_POSITION_INDEPENDENT_CODE ON)
      endif()
    else()
      set(CMAKE_POSITION_INDEPENDENT_CODE ON)
    endif()
  endif()

else()
  find_package(Qt4 4.7 QUIET REQUIRED QtCore QtMain)

  # Workaround qt4 moc bug, see https://bugzilla.redhat.com/show_bug.cgi?id=1396755
  add_definitions(-D_SYS_SYSMACROS_H_OUTER)
endif()

set(CMAKE_INCLUDE_CURRENT_DIR TRUE)
set(CMAKE_AUTOMOC TRUE)

add_definitions(-DQT_NO_CAST_TO_ASCII -DQT_NO_CAST_FROM_ASCII -DQT_NO_CAST_FROM_BYTEARRAY)
add_definitions(-DUSE_EXCEPTIONS -DQT_FATAL_ASSERT)
if(MSVC)
  add_definitions(-D_SCL_SECURE_NO_WARNINGS)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR "${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang")
  include(CheckCXXCompilerFlag)
  check_cxx_compiler_flag(-Wsuggest-override HAVE_GXX_SUGGEST_OVERRIDE)
  if(HAVE_GXX_SUGGEST_OVERRIDE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wsuggest-override")
  endif()
endif()

if(${PROJECT_NAME}_STATIC)
  set(${PROJECT_NAME}_LIBRARY_MODE "STATIC")
else()
  set(${PROJECT_NAME}_LIBRARY_MODE "SHARED")
endif()

if(CMAKE_SOURCE_DIR STREQUAL PROJECT_SOURCE_DIR)
  set(${PROJECT_NAME}_IS_ROOT_PROJECT TRUE)

  if(CMAKE_BUILD_TYPE MATCHES "Release")
    add_definitions(-DNDEBUG)
  endif()

  if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Debug" CACHE STRING "" FORCE)
  endif()

  if(USE_DEFAULT_INSTALL_LOCATION)
    if(UNIX)
      set(CMAKE_INSTALL_PREFIX "/usr/local/KDAB/${PROJECT_NAME}-${${PROJECT_NAME}_VERSION}")
    elseif(WIN32)
      set(CMAKE_INSTALL_PREFIX "C:\\KDAB\\${PROJECT_NAME}-${${PROJECT_NAME}_VERSION}")
    endif()
  endif()

  message(STATUS "Building ${PROJECT_NAME} ${${PROJECT_NAME}_VERSION} in ${CMAKE_BUILD_TYPE} mode. Installing to ${CMAKE_INSTALL_PREFIX}")

  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/bin")
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/lib")
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/lib")

  install(FILES LICENSE.GPL.txt LICENSE.US.txt LICENSE.txt README.txt kdsoap.pri kdwsdl2cpp.pri DESTINATION ${INSTALL_DOC_DIR})

  if(CMAKE_VERSION VERSION_LESS 2.8.8)
    include("${CMAKE_SOURCE_DIR}/cmake/CMakePackageConfigHelpers.cmake")
  else()
    include(CMakePackageConfigHelpers)
  endif()

  write_basic_package_version_file("${CMAKE_CURRENT_BINARY_DIR}/KDSoap/KDSoapConfigVersion.cmake"
    VERSION ${${PROJECT_NAME}_VERSION}
    COMPATIBILITY AnyNewerVersion
  )

  configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/KDSoapConfig-buildtree.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/KDSoap/KDSoapConfig.cmake"
    @ONLY
  )
  file(COPY
    "${CMAKE_CURRENT_SOURCE_DIR}/KDSoapMacros.cmake"
    DESTINATION
    "${CMAKE_CURRENT_BINARY_DIR}/KDSoap/"
  )
  configure_package_config_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/KDSoapConfig.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/install/KDSoapConfig.cmake"
    INSTALL_DESTINATION "${INSTALL_LIBRARY_DIR}/cmake/KDSoap"
    PATH_VARS INSTALL_INCLUDE_DIR
  )

  install(FILES
      "${CMAKE_CURRENT_BINARY_DIR}/install/KDSoapConfig.cmake"
      "${CMAKE_CURRENT_BINARY_DIR}/KDSoap/KDSoapConfigVersion.cmake"
      KDSoapMacros.cmake
    DESTINATION "${INSTALL_LIBRARY_DIR}/cmake/KDSoap"
  )
  install(EXPORT KDSoapTargets NAMESPACE KDSoap::
    DESTINATION "${INSTALL_LIBRARY_DIR}/cmake/KDSoap"
  )
endif()

add_subdirectory(src)
add_subdirectory(kdwsdl2cpp)
if(${PROJECT_NAME}_IS_ROOT_PROJECT)

  export(TARGETS kdsoap kdsoap-server kdwsdl2cpp NAMESPACE KDSoap::
    FILE "${CMAKE_CURRENT_BINARY_DIR}/KDSoap/KDSoapTargets.cmake"
  )

  add_subdirectory(features)
  if(${PROJECT_NAME}_TESTS)
    enable_testing()
    add_subdirectory(testtools)
    add_subdirectory(unittests)
  endif()
  if(${PROJECT_NAME}_EXAMPLES)
    add_subdirectory(examples)
  endif()
endif()

=== examples/CMakeLists.txt ===
set(CMAKE_INCLUDE_CURRENT_DIR ON)
include(${QT_USE_FILE})

if(Qt5Core_FOUND)
  find_package(Qt5Widgets REQUIRED)
  set(QT_QTWIDGETS_LIBRARY Qt5::Widgets)
else()
  set(QT_QTWIDGETS_LIBRARY)
endif()

include(../KDSoapMacros.cmake)
include_directories(../src/ ../src/KDSoapClient/ ../src/KDSoapServer/)
if(Qt5Widgets_FOUND)
  add_subdirectory(helloworld_client)
  add_subdirectory(helloworld_server)
  add_subdirectory(bank_gui)
endif()
add_subdirectory(bank_wsdl)

=== features/CMakeLists.txt ===
install(FILES kdsoap.prf DESTINATION ${INSTALL_DATADIR}/mkspecs/features )

=== kdwsdl2cpp/CMakeLists.txt ===
set(QT_USE_QTNETWORK TRUE)
set(QT_USE_QTXML TRUE)
include(${QT_USE_FILE})

remove_definitions(-DQT_NO_CAST_TO_ASCII -DQT_NO_CAST_FROM_ASCII -DQT_NO_CAST_FROM_BYTEARRAY)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(SOURCES_LIB
  common/fileprovider.cpp
  common/messagehandler.cpp
  common/nsmanager.cpp
  common/parsercontext.cpp
  common/qname.cpp
  libkode/code.cpp
  libkode/enum.cpp
  libkode/style.cpp
  libkode/printer.cpp
  libkode/license.cpp
  libkode/file.cpp
  libkode/class.cpp
  libkode/function.cpp
  libkode/variable.cpp
  libkode/membervariable.cpp
  libkode/typedef.cpp
  libkode/statemachine.cpp
  schema/annotation.cpp
  schema/attribute.cpp
  schema/complextype.cpp
  schema/element.cpp
  schema/parser.cpp
  schema/simpletype.cpp
  schema/types.cpp
  schema/xmlelement.cpp
  schema/xsdtype.cpp
  schema/attributegroup.cpp
  schema/compositor.cpp
  schema/group.cpp
  wsdl/binding.cpp
  wsdl/bindingoperation.cpp
  wsdl/definitions.cpp
  wsdl/element.cpp
  wsdl/fault.cpp
  wsdl/import.cpp
  wsdl/message.cpp
  wsdl/operation.cpp
  wsdl/param.cpp
  wsdl/part.cpp
  wsdl/port.cpp
  wsdl/porttype.cpp
  wsdl/service.cpp
  wsdl/soapbinding.cpp
  wsdl/type.cpp
  wsdl/wsdl.cpp
  src/compiler.cpp
  src/converter.cpp
  src/converter_clientstub.cpp
  src/converter_complextype.cpp
  src/converter_serverstub.cpp
  src/converter_simpletype.cpp
  src/creator.cpp
  src/elementargumentserializer.cpp
  src/namemapper.cpp
  src/settings.cpp
  src/typemap.cpp
)

set(SOURCES_EXE src/main.cpp)

add_library(kdwsdl2cpp_lib STATIC ${SOURCES_LIB})
target_link_libraries(kdwsdl2cpp_lib ${QT_LIBRARIES})

add_executable(kdwsdl2cpp ${SOURCES_EXE})
target_link_libraries(kdwsdl2cpp kdwsdl2cpp_lib ${QT_LIBRARIES})

install(TARGETS kdwsdl2cpp EXPORT "KDSoapTargets"
  RUNTIME DESTINATION ${INSTALL_RUNTIME_DIR}
  BUNDLE DESTINATION .
)

=== src/CMakeLists.txt ===
add_subdirectory(KDSoapClient)
add_subdirectory(KDSoapServer)

=== testtools/CMakeLists.txt ===
set(QT_USE_QTNETWORK TRUE)
set(QT_USE_QTXML TRUE)
include(${QT_USE_FILE})
include_directories(.. ../src/KDSoapClient)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(testtools_srcs httpserver_p.cpp)

qt4_add_resources(testtools_srcs testtools.qrc)

add_library(testtools STATIC ${testtools_srcs})
target_link_libraries(testtools ${QT_LIBRARIES})
if(Qt5_POSITION_INDEPENDENT_CODE)
  set_target_properties(testtools PROPERTIES POSITION_INDEPENDENT_CODE TRUE)
endif()

=== examples/bank_gui/CMakeLists.txt ===
project(bank_gui)

include_directories(${QT_QTGUI_INCLUDE_DIR})

set(bank_gui_SRCS bank_gui.cpp mainwindow.cpp)

KDSOAP_GENERATE_WSDL(bank_gui_SRCS BLZService.wsdl)

qt4_add_resources(bank_gui_SRCS resources.qrc)

add_executable(bank_gui ${bank_gui_SRCS})
target_link_libraries(bank_gui ${QT_QTCORE_LIBRARY} ${QT_QTXML_LIBRARY} ${QT_QTGUI_LIBRARY} ${QT_QTWIDGETS_LIBRARY} kdsoap)

=== examples/bank_wsdl/CMakeLists.txt ===
project( bank_wsdl )

set(bank_wsdl_SRCS bank_wsdl.cpp)

KDSOAP_GENERATE_WSDL(bank_wsdl_SRCS BLZService.wsdl)

add_executable(bank_wsdl ${bank_wsdl_SRCS})
target_link_libraries(bank_wsdl ${QT_QTCORE_LIBRARY} kdsoap)

=== examples/helloworld_client/CMakeLists.txt ===
project(helloworld_client)

include_directories(${QT_QTGUI_INCLUDE_DIR})

set(helloworld_client_SRCS main.cpp)

set(helloworld_client_HRDS helloworld_client.h )
qt4_wrap_cpp( helloworld_client_MOCS ${helloworld_client_HRDS} )

KDSOAP_GENERATE_WSDL(helloworld_client_SRCS helloworld.wsdl )

add_executable(helloworld_client ${helloworld_client_SRCS} ${helloworld_client_MOCS} )
target_link_libraries(helloworld_client ${QT_QTCORE_LIBRARY} ${QT_QTXML_LIBRARY} ${QT_QTGUI_LIBRARY} ${QT_QTWIDGETS_LIBRARY} kdsoap)

=== examples/helloworld_server/CMakeLists.txt ===
project(helloworld_server)

set(KSWSDL2CPP_OPTION "-server")
set(helloworld_server_SRCS main.cpp)
set(helloworld_server_HDRS helloworld_server.h)

KDSOAP_GENERATE_WSDL(helloworld_server_SRCS helloworld.wsdl)

qt4_wrap_cpp( helloworld_server_MOCS ${helloworld_server_HDRS} )

add_executable(helloworld_server ${helloworld_server_SRCS} ${helloworld_server_MOCS} )
target_link_libraries(helloworld_server ${QT_QTCORE_LIBRARY} ${QT_QTXML_LIBRARY} kdsoap kdsoap-server)

=== src/KDSoapClient/CMakeLists.txt ===
set(QT_USE_QTNETWORK TRUE)
include(${QT_USE_FILE})
set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(SOURCES
  KDSoapMessage.cpp
  KDSoapClientInterface.cpp
  KDSoapPendingCall.cpp
  KDSoapPendingCallWatcher.cpp
  KDSoapClientThread.cpp
  KDSoapValue.cpp
  KDSoapAuthentication.cpp
  KDSoapNamespaceManager.cpp
  KDSoapMessageWriter.cpp
  KDSoapMessageReader.cpp
  KDDateTime.cpp
  KDSoapNamespacePrefixes.cpp
  KDSoapJob.cpp
  KDSoapSslHandler.cpp
  KDSoapReplySslHandler.cpp
  KDSoapFaultException.cpp
  KDSoapMessageAddressingProperties.cpp
  KDSoapEndpointReference.cpp
  KDQName.cpp
  KDSoapUdpClient.cpp
)

add_library(kdsoap ${KDSoap_LIBRARY_MODE} ${SOURCES})
if(${PROJECT_NAME}_STATIC)
  target_compile_definitions(kdsoap PUBLIC KDSOAP_STATICLIB)
else()
  target_compile_definitions(kdsoap PRIVATE KDSOAP_BUILD_KDSOAP_LIB)
endif()
target_link_libraries(kdsoap ${QT_LIBRARIES})
set_target_properties(kdsoap PROPERTIES
  SOVERSION ${${PROJECT_NAME}_SOVERSION}
  VERSION ${${PROJECT_NAME}_VERSION}
)
target_include_directories(kdsoap INTERFACE "$<INSTALL_INTERFACE:${CMAKE_INSTALL_PREFIX}/${INSTALL_INCLUDE_DIR}>")

#version libraries on Windows
if(WIN32)
  set(postfix ${${PROJECT_NAME}_SOVERSION})
  set(CMAKE_RELEASE_POSTFIX ${postfix})
  set_target_properties(kdsoap PROPERTIES RELEASE_POSTFIX ${CMAKE_RELEASE_POSTFIX})
  #append 'd' to debug libraries
  string(CONCAT postfix ${postfix} "d")
  set(CMAKE_DEBUG_POSTFIX ${postfix})
  set_target_properties(kdsoap PROPERTIES DEBUG_POSTFIX ${CMAKE_DEBUG_POSTFIX})
endif()

if(KDSoap_IS_ROOT_PROJECT)
  include(ECMGenerateHeaders)
  ecm_generate_headers(client_HEADERS
    ORIGINAL
      CAMELCASE
    HEADER_NAMES
      KDSoapGlobal
      KDSoapMessage,KDSoapHeaders
      KDSoap
      KDDateTime
      KDSoapJob
      KDSoapClientInterface
      KDSoapNamespaceManager
      KDSoapSslHandler
      KDSoapValue,KDSoapValueList
      KDSoapPendingCallWatcher
      KDSoapFaultException
      KDSoapMessageAddressingProperties
      KDSoapEndpointReference
      KDSoapPendingCall
      KDSoapAuthentication
      KDQName
      KDSoapUdpClient
    COMMON_HEADER
      KDSoapClient
  )

  install(FILES
    ${client_HEADERS}
    KDSoapMessage.h
    KDSoapClientInterface.h
    KDSoapPendingCall.h
    KDSoapPendingCallWatcher.h
    KDSoapValue.h
    KDSoapGlobal.h
    KDSoapJob.h
    KDSoapAuthentication.h
    KDSoapNamespaceManager.h
    KDDateTime.h
    KDSoap.h
    KDSoapSslHandler.h
    KDSoapFaultException.h
    KDSoapMessageAddressingProperties.h
    KDSoapEndpointReference.h
    KDQName.h
    KDSoapUdpClient.h
    DESTINATION ${INSTALL_INCLUDE_DIR}/KDSoapClient
  )

  install(TARGETS kdsoap EXPORT KDSoapTargets
    RUNTIME DESTINATION ${INSTALL_RUNTIME_DIR}
    LIBRARY DESTINATION ${INSTALL_LIBRARY_DIR}
    ARCHIVE DESTINATION ${INSTALL_ARCHIVE_DIR}
    )

endif()

=== src/KDSoapServer/CMakeLists.txt ===
set(QT_USE_QTNETWORK TRUE)
include(${QT_USE_FILE})
set(CMAKE_INCLUDE_CURRENT_DIR ON)

include_directories(.. ../KDSoapClient)

set(SOURCES
  KDSoapDelayedResponseHandle.cpp
  KDSoapServer.cpp
  KDSoapServerObjectInterface.cpp
  KDSoapServerSocket.cpp
  KDSoapServerThread.cpp
  KDSoapServerThread.cpp
  KDSoapServerThread.cpp
  KDSoapServerAuthInterface.cpp
  KDSoapServerRawXMLInterface.cpp
  KDSoapServerCustomVerbRequestInterface.cpp
  KDSoapSocketList.cpp
  KDSoapThreadPool.cpp
)

set_source_files_properties(KDSoapServerObjectInterface.cpp PROPERTIES SKIP_AUTOMOC TRUE)
add_library(kdsoap-server ${KDSoap_LIBRARY_MODE} ${SOURCES})
if(${PROJECT_NAME}_STATIC)
  target_compile_definitions(kdsoap-server PUBLIC KDSOAPSERVER_STATICLIB)
else()
  target_compile_definitions(kdsoap-server PRIVATE KDSOAP_BUILD_KDSOAPSERVER_LIB)
endif()
target_link_libraries(kdsoap-server kdsoap ${QT_LIBRARIES})
set_target_properties(kdsoap-server PROPERTIES
  SOVERSION ${${PROJECT_NAME}_SOVERSION}
  VERSION ${${PROJECT_NAME}_VERSION}
)
target_include_directories(kdsoap-server INTERFACE "$<INSTALL_INTERFACE:${CMAKE_INSTALL_PREFIX}/${INSTALL_INCLUDE_DIR}>")

#version libraries on Windows
if(WIN32)
  set(postfix ${${PROJECT_NAME}_SOVERSION})
  set(CMAKE_RELEASE_POSTFIX ${postfix})
  set_target_properties(kdsoap-server PROPERTIES RELEASE_POSTFIX ${CMAKE_RELEASE_POSTFIX})
  #append 'd' to debug libraries
  string(CONCAT postfix ${postfix} "d")
  set(CMAKE_DEBUG_POSTFIX ${postfix})
  set_target_properties(kdsoap-server PROPERTIES DEBUG_POSTFIX ${CMAKE_DEBUG_POSTFIX})
endif()

if(KDSoap_IS_ROOT_PROJECT)
  include(ECMGenerateHeaders)
  ecm_generate_headers(server_HEADERS
    ORIGINAL
      CAMELCASE
    HEADER_NAMES
      KDSoapDelayedResponseHandle
      KDSoapServerGlobal
      KDSoapThreadPool
      KDSoapServerObjectInterface
      KDSoapServerAuthInterface
      KDSoapServerRawXMLInterface
      KDSoapServerCustomVerbRequestInterface
    COMMON_HEADER
      KDSoapServer
  )

  set(COMBINED_H ${CMAKE_CURRENT_BINARY_DIR}/KDSoapServer)
  file(APPEND ${COMBINED_H} "#include \"KDSoapServer.h\"\n")

  install(FILES
    ${server_HEADERS}
    KDSoapServer.h
    KDSoapServerAuthInterface.h
    KDSoapServerRawXMLInterface.h
    KDSoapServerCustomVerbRequestInterface.h
    KDSoapDelayedResponseHandle.h
    KDSoapServerObjectInterface.h
    KDSoapServerGlobal.h
    KDSoapThreadPool.h
    DESTINATION ${INSTALL_INCLUDE_DIR}/KDSoapServer
  )

  install(TARGETS kdsoap-server EXPORT KDSoapTargets
    RUNTIME DESTINATION ${INSTALL_RUNTIME_DIR}
    LIBRARY DESTINATION ${INSTALL_LIBRARY_DIR}
    ARCHIVE DESTINATION ${INSTALL_ARCHIVE_DIR}
  )

endif()

=== debian/changelog ===
kdsoap (1.9.1+dfsg-5ubuntu3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 01:30:59 +0000

kdsoap (1.9.1+dfsg-5ubuntu2) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 04:54:46 +0000

kdsoap (1.9.1+dfsg-5ubuntu1) jammy; urgency=medium

  * Mark some symbols optional to prevent FTBFS on ppc64el.

 -- Rik Mills <rikmills@kde.org>  Thu, 24 Feb 2022 12:45:57 +0000

kdsoap (1.9.1+dfsg-5) unstable; urgency=medium

  * Update symbols files for mipsel, mips64el, alpha, hppa and sparc64 architectures.
  * Update debian/watch file.

 -- Thomas Pierson <contact@thomaspierson.fr>  Mon, 21 Feb 2022 22:09:27 +0100

kdsoap (1.9.1+dfsg-4) unstable; urgency=medium

  * Update symbols files for all architectures.

 -- Thomas Pierson <contact@thomaspierson.fr>  Sat, 12 Feb 2022 10:48:48 +0100

kdsoap (1.9.1+dfsg-3) unstable; urgency=medium

  * Update symbols files for amd64 architectures. (Closes: #997406)

 -- Thomas Pierson <contact@thomaspierson.fr>  Fri, 11 Feb 2022 23:17:12 +0100

kdsoap (1.9.1+dfsg-2) unstable; urgency=medium

  * Source only upload.
  * Update symbols files for all architectures.

 -- Thomas Pierson <contact@thomaspierson.fr>  Wed, 11 Nov 2020 09:17:49 +0100

kdsoap (1.9.1+dfsg-1) unstable; urgency=medium

  * Initial release. (Closes: #971913)

 -- Thomas Pierson <contact@thomaspierson.fr>  Thu, 08 Oct 2020 08:47:59 +0200

=== debian/control ===
Source: kdsoap
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Thomas Pierson <contact@thomaspierson.fr>
Build-Depends: cmake (>= 2.8.7),
               debhelper-compat (= 13),
               libboost-dev (>= 1.34.0~),
               pkg-kde-tools (>= 0.12),
               qtbase5-dev (>= 5.11.0~)
Standards-Version: 4.5.0
Section: libs
Homepage: https://www.kdab.com/development-resources/qt-tools/kd-soap/
Vcs-Browser: https://salsa.debian.org/thomaspi-guest/pkg-kdsoap
Vcs-Git: https://salsa.debian.org/thomaspi-guest/pkg-kdsoap.git
Rules-Requires-Root: no

Package: libkdsoap-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: libkdsoap-dev
Description: Qt-based client-side and server-side SOAP component - documentation
 Qt-based client-side and server-side SOAP component. It can be used to
 create client applications for web services and also provides the means to
 create web services without the need for any further component such as a
 dedicated web server.
 .
 This package contains the documentation.

Package: libkdsoap-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: qtbase5-dev (>= 5.11.0~),
         libkdsoap1 (= ${binary:Version}),
         libkdsoap-bin (= ${binary:Version}),
         libkdsoap-server1 (= ${binary:Version}),
         ${misc:Depends}
Suggests: libkdsoap-doc
Description: Qt-based client-side and server-side SOAP component - devel files
 Qt-based client-side and server-side SOAP component. It can be used to
 create client applications for web services and also provides the means to
 create web services without the need for any further component such as a
 dedicated web server.
 .
 This package contains the development files

Package: libkdsoap-bin
Section: libs
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Qt-based client-side and server-side SOAP component - binaries
 Qt-based client-side and server-side SOAP component. It can be used to
 create client applications for web services and also provides the means to
 create web services without the need for any further component such as a
 dedicated web server.
 .
 This package contains some utilities and example programs for the library.


Package: libkdsoap1
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Qt-based client-side and server-side SOAP component - client-side library
 Qt-based client-side and server-side SOAP component. It can be used to
 create client applications for web services and also provides the means to
 create web services without the need for any further component such as a
 dedicated web server.
 .
 This package contains the client-side library

Package: libkdsoap-server1
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Qt-based client-side and server-side SOAP component - server-side library
 Qt-based client-side and server-side SOAP component. It can be used to
 create client applications for web services and also provides the means to
 create web services without the need for any further component such as a
 dedicated web server.
 .
 This package contains the server-side library

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with pkgkde_symbolshelper

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_BUILD_TYPE=Debug \
	-DCMAKE_INSTALL_PREFIX=/usr

## kdsoap 2.2.0

=== debian/changelog ===
kdsoap (2.2.0-0ubuntu1) oracular; urgency=medium

  * Release to archive. 

 -- Scarlett Moore <sgmoore@debian.org>  Wed, 28 Aug 2024 07:04:52 -0700

kdsoap (2.2.0-0ubuntu11~ubuntu24.10~ppa8) oracular; urgency=medium

  * Hard code qmake command. 

 -- Scarlett Moore <sgmoore@debian.org>  Fri, 23 Aug 2024 01:30:35 -0700

kdsoap (2.2.0-0ubuntu11~ubuntu24.10~ppa7) oracular; urgency=medium

  * Try qtchooser to install qt.conf 

 -- Scarlett Moore <sgmoore@debian.org>  Fri, 23 Aug 2024 00:37:15 -0700

kdsoap (2.2.0-0ubuntu11~ubuntu24.10~ppa6) oracular; urgency=medium

  * Try and drop depreciated LOCAtiON 

 -- Scarlett Moore <sgmoore@debian.org>  Fri, 23 Aug 2024 00:24:42 -0700

kdsoap (2.2.0-0ubuntu11~ubuntu24.10~ppa5) oracular; urgency=medium

  * Patch cmake to find qmake6. 

 -- Scarlett Moore <sgmoore@debian.org>  Thu, 22 Aug 2024 23:30:58 -0700

kdsoap (2.2.0-0ubuntu11~ubuntu24.10~ppa4) oracular; urgency=medium

  * Also set QT_VERSION_MAJOR.

 -- Scarlett Moore <sgmoore@debian.org>  Thu, 22 Aug 2024 09:40:38 -0700

kdsoap (2.2.0-0ubuntu11~ubuntu24.10~ppa3) oraculaUNRELEASEDr; urgency=medium

  * Use qtchooser. 

 -- Scarlett Moore <sgmoore@debian.org>  Thu, 22 Aug 2024 08:28:15 -0700

kdsoap (2.2.0-0ubuntu11~ubuntu24.10~ppa2) oracular; urgency=medium

  * Patch symbols in from defferent arches.

 -- Scarlett Moore <sgmoore@debian.org>  Wed, 21 Aug 2024 09:53:37 -0700

kdsoap (2.2.0-0ubuntu11~ubuntu24.10~ppa1) oracular; urgency=medium

  * New upstream release (2.2.0).
  * Update dependencies.
  * Update to Kubuntu VCS. 
  * Update packages to qt6.
  * Refresh symbols files.
  * Rename manpage. 

 -- Scarlett Moore <sgmoore@debian.org>  Thu, 15 Aug 2024 08:26:11 -0700

=== debian/control ===
--- 
+++ 
@@ -4,21 +4,27 @@
 XSBC-Original-Maintainer: Thomas Pierson <contact@thomaspierson.fr>
 Build-Depends: cmake (>= 2.8.7),
                debhelper-compat (= 13),
-               libboost-dev (>= 1.34.0~),
-               pkg-kde-tools (>= 0.12),
-               qtbase5-dev (>= 5.11.0~)
+               dh-sequence-kf6,
+               doxygen,
+               pkg-kde-tools,
+               graphviz,
+               qmake6,
+               qtchooser,
+               qt6-base-dev,
+               qt6-tools-dev,
+               texlive
 Standards-Version: 4.5.0
 Section: libs
 Homepage: https://www.kdab.com/development-resources/qt-tools/kd-soap/
-Vcs-Browser: https://salsa.debian.org/thomaspi-guest/pkg-kdsoap
-Vcs-Git: https://salsa.debian.org/thomaspi-guest/pkg-kdsoap.git
+Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kdsoap
+Vcs-Git: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kdsoap.git
 Rules-Requires-Root: no
 
-Package: libkdsoap-doc
+Package: libkdsoap-qt6-doc
 Section: doc
 Architecture: all
 Depends: ${misc:Depends}
-Suggests: libkdsoap-dev
+Suggests: libkdsoap-qt6-dev
 Description: Qt-based client-side and server-side SOAP component - documentation
  Qt-based client-side and server-side SOAP component. It can be used to
  create client applications for web services and also provides the means to
@@ -27,16 +33,16 @@
  .
  This package contains the documentation.
 
-Package: libkdsoap-dev
+Package: libkdsoap-qt6-dev
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: qtbase5-dev (>= 5.11.0~),
-         libkdsoap1 (= ${binary:Version}),
-         libkdsoap-bin (= ${binary:Version}),
-         libkdsoap-server1 (= ${binary:Version}),
+Depends: qt6-base-dev (>= 6.5.0+dfsg~),
+         libkdsoap-qt6-2 (= ${binary:Version}),
+         libkdsoap-qt6-bin (= ${binary:Version}),
+         libkdsoap-server-qt6-2 (= ${binary:Version}),
          ${misc:Depends}
-Suggests: libkdsoap-doc
+Suggests: libkdsoap-qt6-doc
 Description: Qt-based client-side and server-side SOAP component - devel files
  Qt-based client-side and server-side SOAP component. It can be used to
  create client applications for web services and also provides the means to
@@ -45,7 +51,7 @@
  .
  This package contains the development files
 
-Package: libkdsoap-bin
+Package: libkdsoap-qt6-bin
 Section: libs
 Architecture: any
 Multi-Arch: foreign
@@ -59,7 +65,7 @@
  This package contains some utilities and example programs for the library.
 
 
-Package: libkdsoap1
+Package: libkdsoap-qt6-2
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -71,7 +77,7 @@
  .
  This package contains the client-side library
 
-Package: libkdsoap-server1
+Package: libkdsoap-server-qt6-2
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed
export QT_SELECT=qt6
export QMAKE="/usr/bin/qmake6"

DEB_HOST_MULTIARCH?=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)


%:
	dh $@ --with pkgkde_symbolshelper

override_dh_auto_configure:
	cp -rfv $(CURDIR)/libkode $(CURDIR)/kdwsdl2cpp/
	dh_auto_configure -- -DKDSoap_DOCS=false -DKDSoap_TESTS=false -DKDSoap_QT6=true -DKDSoap_EXAMPLES=true -DQT_VERSION_MAJOR=6

=== debian/watch ===
version=4
opts="searchmode=plain, \
filenamemangle=s/.+\/@PACKAGE@-@ANY_VERSION@\.tar\.gz/@PACKAGE@-$1\.tar\.gz/" \
https://api.github.com/repos/KDAB/KDSoap/releases \
https://github.com/KDAB/KDSoap/releases/download/@PACKAGE@-?\d[\.\d]*/@PACKAGE@-@ANY_VERSION@.tar.gz

opts=mode=git,\
component=libkode \
https://github.com/cornelius/libkode \
HEAD ignore same uupdate

## kdsoap 2.2.0%2Bdfsg

=== docs/api/CMakeLists.txt ===
# This file is part of the KD Soap project.
#
# SPDX-FileCopyrightText: 2021 Klarälvdalens Datakonsult AB, a KDAB Group company <info@kdab.com>
#
# SPDX-License-Identifier: MIT
#

# dot should come with Doxygen find_package(Doxygen)
if(DOXYGEN_DOT_EXECUTABLE)
    set(HAVE_DOT "YES")
else()
    set(HAVE_DOT "NO")
    message(STATUS "Unable to provide inheritance diagrams for the API documentation. "
                   "To fix, install the graphviz project from https://www.graphviz.org"
    )
endif()

# latex
set(HAVE_LATEX "NO")
find_package(LATEX)
set_package_properties(
    LATEX PROPERTIES
    TYPE OPTIONAL
    DESCRIPTION "A document preparation system"
    URL "https://www.latex-project.org"
    PURPOSE "Provides for building a PS or PDF version of the API documentation"
)
if(LATEX_FOUND)
    if(MAKEINDEX_COMPILER)
        set(HAVE_LATEX "YES")
    else()
        message(STATUS "The LaTeX makeindex compiler could not be located. "
                       "Unable to generate the buildsystem for LaTex documentation generation."
        )
    endif()
endif()

# qhelpgenerator
find_program(QHELPGEN_EXECUTABLE qhelpgenerator HINTS ${QT_INSTALL_BINS})
if(QHELPGEN_EXECUTABLE)
    set(HAVE_QHELPGEN "YES")
else()
    set(HAVE_QHELPGEN "NO")
    message(STATUS "Unable to generate the API documentation in qch format. "
                   "To fix, install the qthelpgenerator program which comes with Qt."
    )
endif()

find_file(QDOC_QTCORE_TAG qtcore.tags HINTS ${QT_INSTALL_DOCS}/qtcore ${QT_INSTALL_DATA}/doc/qtcore)
set(QDOC_TAG_DIR "<QDOC_TAG_DIR_not_found>")
if(QDOC_QTCORE_TAG)
    get_filename_component(QDOC_TAG_DIR ${QDOC_QTCORE_TAG} DIRECTORY)
    get_filename_component(QDOC_TAG_DIR ${QDOC_TAG_DIR} DIRECTORY)
endif()

file(GLOB _dox_deps *.dox *.html)
set(DOXYGEN_OUTPUT_DIR ${CMAKE_CURRENT_BINARY_DIR})

#apidox generation using doxygen
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.cmake ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)

add_custom_command(
    OUTPUT ${DOXYGEN_OUTPUT_DIR}/qch/kdsoap-api.qch
    COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
    DEPENDS ${_dox_deps} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    COMMENT "Generate the .qch file"
)
add_custom_target(
    kdsoap-api.qch ALL
    DEPENDS ${DOXYGEN_OUTPUT_DIR}/qch/kdsoap-api.qch
    COMMENT "Target to generate the .qch file"
)
add_custom_target(
    docs
    DEPENDS kdsoap-api.qch
    COMMENT "Target to generate the documentation"
)

set(QCH_INSTALL_DIR
    ${INSTALL_DOC_DIR}
    CACHE STRING "Install location of Qt Assistant help files."
)
install(
    FILES ${DOXYGEN_OUTPUT_DIR}/qch/kdsoap-api.qch
    DESTINATION ${QCH_INSTALL_DIR}
)
install(
    FILES ${DOXYGEN_OUTPUT_DIR}/kdsoap.tags
    DESTINATION ${INSTALL_DOC_DIR}
)

=== src/KDSoapClient/CMakeLists.txt ===
# This file is part of the KD Soap project.
#
# SPDX-FileCopyrightText: 2012 Klarälvdalens Datakonsult AB, a KDAB Group company <info@kdab.com>
#
# SPDX-License-Identifier: MIT
#

set(SOURCES
    KDSoapMessage.cpp
    KDSoapClientInterface.cpp
    KDSoapPendingCall.cpp
    KDSoapPendingCallWatcher.cpp
    KDSoapClientThread.cpp
    KDSoapValue.cpp
    KDSoapAuthentication.cpp
    KDSoapNamespaceManager.cpp
    KDSoapMessageWriter.cpp
    KDSoapMessageReader.cpp
    KDDateTime.cpp
    KDSoapNamespacePrefixes.cpp
    KDSoapJob.cpp
    KDSoapSslHandler.cpp
    KDSoapReplySslHandler.cpp
    KDSoapFaultException.cpp
    KDSoapMessageAddressingProperties.cpp
    KDSoapEndpointReference.cpp
    KDQName.cpp
    KDSoapUdpClient.cpp
)

add_library(
    kdsoap
    ${KDSoap_LIBRARY_MODE} ${SOURCES}
)
add_library(
    KDSoap::kdsoap ALIAS kdsoap
)

set_target_properties(kdsoap PROPERTIES OUTPUT_NAME "kdsoap${${PROJECT_NAME}_LIBRARY_QTID}")
if(${PROJECT_NAME}_STATIC)
    target_compile_definitions(kdsoap PUBLIC KDSOAP_STATICLIB)
else()
    target_compile_definitions(kdsoap PRIVATE KDSOAP_BUILD_KDSOAP_LIB)
endif()
target_link_libraries(
    kdsoap ${QT_LIBRARIES}
)
if(${PROJECT_NAME}_QT6)
    set(client_INCLUDE_DIR ${INSTALL_INCLUDE_DIR}/KDSoapClient-Qt6)
else()
    set(client_INCLUDE_DIR ${INSTALL_INCLUDE_DIR})
endif()
target_include_directories(
    kdsoap
    INTERFACE "$<INSTALL_INTERFACE:${client_INCLUDE_DIR}>"
)
set_target_properties(kdsoap PROPERTIES SOVERSION ${${PROJECT_NAME}_SOVERSION} VERSION ${${PROJECT_NAME}_VERSION})

#version libraries on Windows
if(WIN32)
    set(postfix ${${PROJECT_NAME}_SOVERSION})
    string(TOUPPER ${CMAKE_BUILD_TYPE} UPPER_BUILD_TYPE)
    if(${UPPER_BUILD_TYPE} MATCHES "^DEBUG")
        string(CONCAT postfix ${postfix} "d")
        set_target_properties(kdsoap PROPERTIES DEBUG_POSTFIX ${postfix})
    else()
        set_target_properties(kdsoap PROPERTIES ${UPPER_BUILD_TYPE}_POSTFIX ${postfix})
    endif()
endif()

include(ECMGenerateHeaders)
ecm_generate_headers(
    client_HEADERS
    ORIGINAL
    CAMELCASE
    HEADER_NAMES
    KDSoapGlobal
    KDSoapMessage,KDSoapHeaders
    KDSoap
    KDDateTime
    KDSoapJob
    KDSoapClientInterface
    KDSoapNamespaceManager
    KDSoapSslHandler
    KDSoapValue,KDSoapValueList
    KDSoapPendingCallWatcher
    KDSoapFaultException
    KDSoapMessageAddressingProperties
    KDSoapEndpointReference
    KDSoapPendingCall
    KDSoapAuthentication
    KDQName
    KDSoapUdpClient
    COMMON_HEADER
    KDSoapClient
)

if(KDSoap_IS_ROOT_PROJECT)
    install(
        FILES ${client_HEADERS}
              KDSoapMessage.h
              KDSoapClientInterface.h
              KDSoapPendingCall.h
              KDSoapPendingCallWatcher.h
              KDSoapValue.h
              KDSoapGlobal.h
              KDSoapJob.h
              KDSoapAuthentication.h
              KDSoapNamespaceManager.h
              KDDateTime.h
              KDSoap.h
              KDSoapSslHandler.h
              KDSoapFaultException.h
              KDSoapMessageAddressingProperties.h
              KDSoapEndpointReference.h
              KDQName.h
              KDSoapUdpClient.h
        DESTINATION ${client_INCLUDE_DIR}/KDSoapClient
    )

    install(
        TARGETS kdsoap
        EXPORT KDSoapTargets
        RUNTIME DESTINATION ${INSTALL_RUNTIME_DIR}
        LIBRARY DESTINATION ${INSTALL_LIBRARY_DIR}
        ARCHIVE DESTINATION ${INSTALL_ARCHIVE_DIR}
    )

    if(MSVC AND NOT ${PROJECT_NAME}_STATIC)
        install(
            FILES "$<TARGET_PDB_FILE_DIR:kdsoap>/$<TARGET_PDB_FILE_NAME:kdsoap>"
            DESTINATION ${INSTALL_RUNTIME_DIR}
            CONFIGURATIONS Debug RelWithDebInfo
        )
    endif()

endif()

=== kdwsdl2cpp/libkode/schema/CMakeLists.txt ===
set(SCHEMA_SOURCES
	annotation.cpp
	attribute.cpp
	attributegroup.cpp
	complextype.cpp
	compositor.cpp
	element.cpp
	group.cpp
	parser.cpp
	#schematest.cpp
	simpletype.cpp
	types.cpp
	xmlelement.cpp
	xsdtype.cpp
)

set(SCHEMA_HEADERS
	annotation.h
	attribute.h
	attributegroup.h
	complextype.h
	compositor.h
	element.h
	group.h
	parser.h
	simpletype.h
	types.h
	xmlelement.h
	xsdtype.h
)

add_library(xmlschema STATIC
	${SCHEMA_SOURCES} ${SCHEMA_HEADERS}
)

target_link_libraries(xmlschema PUBLIC
        Qt${QT_MAJOR_VERSION}::Xml
        xmlcommon
)

target_include_directories(xmlschema PUBLIC
   "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>"
)

set_target_properties(xmlschema PROPERTIES OUTPUT_NAME "xmlschema${kode_LIBRARY_QTID}")

=== debian/watch ===
version=4
opts=\
repacksuffix=+dfsg,\
repack,compression=xz,\
dversionmangle=s/\+dfsg\d*$//,\
filenamemangle=s/.*\/kdsoap\-?(\d\S+)\.tar\.gz/kdsoap-$1\.tar\.gz/ \
  https://github.com/KDAB/KDSoap/tags .*/archive/refs/tags/kdsoap\-?(\d\S+)\.tar\.gz
